'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _decorateComponentWithProps = require('decorate-component-with-props');

var _decorateComponentWithProps2 = _interopRequireDefault(_decorateComponentWithProps);

var _isUrl = require('is-url');

var _isUrl2 = _interopRequireDefault(_isUrl);

var _constants = require('./constants');

var _addEmbeder2 = require('./modifiers/addEmbeder');

var _addEmbeder3 = _interopRequireDefault(_addEmbeder2);

var _DefaultEmbederComponent = require('./components/DefaultEmbederComponent');

var _DefaultEmbederComponent2 = _interopRequireDefault(_DefaultEmbederComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultOnReturn = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', {});

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function defaultOnReturn() {
    return _ref.apply(this, arguments);
  };
}();

var embederPlugin = function embederPlugin(_ref2) {
  var theme = _ref2.theme,
      _ref2$embederComponen = _ref2.embederComponent,
      Embeder = _ref2$embederComponen === undefined ? _DefaultEmbederComponent2.default : _ref2$embederComponen,
      decorator = _ref2.decorator,
      _ref2$options = _ref2.options;
  _ref2$options = _ref2$options === undefined ? {} : _ref2$options;
  var _ref2$options$shouldH = _ref2$options.shouldHandleOnReturn,
      shouldHandleOnReturn = _ref2$options$shouldH === undefined ? true : _ref2$options$shouldH,
      _ref2$options$onRetur = _ref2$options.onReturn,
      onReturn = _ref2$options$onRetur === undefined ? defaultOnReturn : _ref2$options$onRetur,
      _ref2$entityType = _ref2.entityType,
      entityType = _ref2$entityType === undefined ? 'draft-js-embeder-plugin-embeder' : _ref2$entityType;

  if (decorator) {
    Embeder = decorator(Embeder); // eslint-disable-line
  }

  var ThemedEmbeder = (0, _decorateComponentWithProps2.default)(Embeder, { theme: theme });

  return {
    blockRendererFn: function blockRendererFn(block, _ref3) {
      var getEditorState = _ref3.getEditorState;

      if (block.getType() === _constants.ATOMIC) {
        var contentState = getEditorState().getCurrentContent();
        var entityKey = block && block.getEntityAt(0);

        if (!entityKey) {
          return;
        }

        var entity = contentState.getEntity(entityKey);
        var type = entity.getType();
        var data = entity.getData();

        if (type === entityType) {
          return {
            component: ThemedEmbeder,
            editable: false,
            props: data
          };
        }
      }
    },
    handleReturn: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(event, editorState, _ref5) {
        var setEditorState = _ref5.setEditorState;
        var contentState, startKey, contentBlock, blockText, data, newState;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (shouldHandleOnReturn) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt('return', 'not-handled');

              case 2:
                contentState = editorState.getCurrentContent();
                startKey = editorState.getSelection().getStartKey();
                contentBlock = contentState.getBlockForKey(startKey);
                blockText = contentBlock.getText().trim();

                if ((0, _isUrl2.default)(blockText)) {
                  _context2.next = 8;
                  break;
                }

                return _context2.abrupt('return', 'not-handled');

              case 8:
                _context2.prev = 8;
                _context2.next = 11;
                return onReturn({ url: blockText });

              case 11:
                _context2.t0 = _context2.sent;

                if (_context2.t0) {
                  _context2.next = 14;
                  break;
                }

                _context2.t0 = {};

              case 14:
                data = _context2.t0;

                if (data.html) {
                  _context2.next = 17;
                  break;
                }

                return _context2.abrupt('return', 'not-handled');

              case 17:
                newState = (0, _addEmbeder3.default)(editorState, (0, _extends3.default)({
                  src: blockText
                }, data), { entityType: entityType });


                setEditorState(newState);

                return _context2.abrupt('return', 'handled');

              case 22:
                _context2.prev = 22;
                _context2.t1 = _context2['catch'](8);
                return _context2.abrupt('return', 'not-handled');

              case 25:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, undefined, [[8, 22]]);
      }));

      return function handleReturn(_x, _x2, _x3) {
        return _ref4.apply(this, arguments);
      };
    }(),
    addEmbeder: function addEmbeder(editorState, data) {
      return (0, _addEmbeder3.default)(editorState, data, { entityType: entityType });
    }
  };
};

exports.default = embederPlugin;