'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _draftJs = require('draft-js');

var _constants = require('../constants');

var addEmbeder = function addEmbeder(editorState, data, config) {
  if (_draftJs.RichUtils.getCurrentBlockType(editorState) === _constants.ATOMIC) {
    return editorState;
  }

  var contentState = editorState.getCurrentContent();
  var contentStateWithEntity = contentState.createEntity(config.entityType, 'IMMUTABLE', data);
  var entityKey = contentStateWithEntity.getLastCreatedEntityKey();

  return _draftJs.AtomicBlockUtils.insertAtomicBlock(editorState, entityKey, ' ');
};

exports.default = addEmbeder;